VERSION 5.00
Begin VB.UserControl IntField 
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1305
   ScaleHeight     =   375
   ScaleWidth      =   1305
   ToolboxBitmap   =   "IntField.ctx":0000
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "mnuPopup"
      Begin VB.Menu mnuPopupCut 
         Caption         =   "Cu&t"
      End
      Begin VB.Menu mnuPopupCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuPopupPaste 
         Caption         =   "&Paste"
      End
      Begin VB.Menu mnuPopupDelete 
         Caption         =   "&Delete"
      End
      Begin VB.Menu mnuPopupSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPopupSelectAll 
         Caption         =   "Select &All"
      End
   End
End
Attribute VB_Name = "IntField"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Error codes:
Public Enum intfield_Errors
    intfield_InvalidInteger = vbObjectError + 1
    intfield_ValueOutOfRange
End Enum

'Default Property Values:
Const m_def_MinValue = -32768
Const m_def_MaxValue = 32767

'Property Variables:
Dim m_MinValue As Integer
Dim m_MaxValue As Integer

'Event Declarations:
Event Change()
' Set KeyValue = 0 if the result of this key press
' would be invalid.
Private Sub CheckText(ByRef KeyValue As Integer, ByVal is_delete As Boolean)
    If Not ValidChange(KeyValue, is_delete) _
        Then KeyValue = 0
End Sub
' See if this change is valid.
Private Function ValidChange(ByVal KeyValue As Integer, ByVal is_delete As Boolean) As Boolean
Dim str_value As String
Dim is_valid As Boolean
Dim int_value As Integer

    ' See what the new value will be.
    str_value = NewValue(KeyValue, is_delete)

    ' See if the new value is valid.
    If Len(str_value) = 0 Then
        ' The text is blank. Allow it.
        is_valid = True
    ElseIf str_value = "-" Then
        ' The text is "-". It might be part of
        ' a negative integer. Allow it if
        ' m_MinValue < 0.
        is_valid = (m_MinValue < 0)
    Else
        ' See if the text is an integer.
        On Error Resume Next
        int_value = CInt(str_value)
        If Err.Number <> 0 Then
            ' The text is not an integer.
            is_valid = False
        Else
            ' See if the value is within bounds.
            is_valid = _
                (int_value >= m_MinValue) And _
                (int_value <= m_MaxValue)
        End If
        On Error GoTo 0
    End If

    ' Return the result.
    ValidChange = is_valid
End Function
' See what the new value would be if this change
' is allowed.
Private Function NewValue(ByVal KeyValue As Integer, ByVal is_delete As Boolean) As String
' Useful ASCII codes.
Const ASC_CTRL_V = 22
Const ASC_CTRL_X = 24
Const FIRST_ASC = 32    ' 1st visible char.
Const LAST_ASC = 126    ' Last visible char.

Dim old_txt As String
Dim part1 As String
Dim part2 As String
Dim part3 As String

    old_txt = txtInput.Text

    ' Find the pieces before and after the section.
    part1 = Left$(old_txt, txtInput.SelStart)
    part3 = Right$(old_txt, Len(old_txt) - txtInput.SelStart - txtInput.SelLength)

    ' Calculate the new text.
    part2 = ""
    If is_delete Then
        ' This is a delete character.
        ' If no text is selected, delete the
        ' following character (if there is one).
        If (txtInput.SelLength <= 0) And _
           (Len(part3) > 0) _
        Then
            part3 = Mid$(part3, 2)
        End If

        ' If text is selected or part3 is blank,
        ' just leave part2 = "".
    Else
        ' This is not a delete character.
        ' See what it is.
        Select Case KeyValue
            Case vbKeyBack      ' Backspace.
                ' If no text is selected, delete the
                ' previous character (if there is one).
                If (txtInput.SelLength <= 0) And _
                   (Len(part1) > 0) _
                Then
                    part1 = Left$(part1, Len(part1) - 1)
                End If
                ' If text is selected or part1 is
                ' blank, leave part2 = "".

            Case ASC_CTRL_V
                ' Paste the clipboard's text over
                ' the selected text.
                part2 = Clipboard.GetText(vbCFText)

            Case ASC_CTRL_X
                ' Leave part2 = "".

            Case FIRST_ASC To LAST_ASC
                ' Use the visible character typed
                ' for the middle string.
                part2 = Chr$(KeyValue)

            Case Else
                ' Assume other non-visible keys
                ' like ^C will not change the text.
                NewValue = old_txt
                Exit Function
        End Select
    End If

    ' Build the result.
    NewValue = part1 & part2 & part3
End Function

' Copy the selected text to the clipboard.
Private Sub mnuPopupCopy_Click()
    txtInput.SetFocus
    SendKeys "^C"
End Sub
' Copy selected text to the clipboard and clear it.
Private Sub mnuPopupCut_Click()
    txtInput.SetFocus
    SendKeys "^X"
End Sub

' Clear the selected text.
Private Sub mnuPopupDelete_Click()
    txtInput.SetFocus

    ' If any text is selected, treat as Delete.
    If txtInput.SelLength > 0 _
        Then SendKeys "{DELETE}"
End Sub


' Paste the clipboard's text if appropriate.
Private Sub mnuPopupPaste_Click()
    txtInput.SetFocus
    SendKeys "^V"
End Sub
' Select all the text.
Private Sub mnuPopupSelectAll_Click()
    txtInput.SelStart = 0
    txtInput.SelLength = Len(txtInput.Text)
    txtInput.SetFocus
End Sub
' Watch for Delete keys.
Private Sub txtInput_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyDelete Then CheckText KeyCode, True
End Sub

' Validate key presses.
Private Sub txtInput_KeyPress(KeyAscii As Integer)
    CheckText KeyAscii, False
End Sub


' Replace the standard context menu with our own.
Private Sub txtInput_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        ' Make Visual Basic discard the mouse capture.
        txtInput.Enabled = False
        txtInput.Enabled = True

        ' Display the popup menu.
        PopupMenu mnuPopup
    End If
End Sub

' Make txtInput as wide as possible. Make the
' control's height fit txtInput.
Private Sub UserControl_Resize()
    txtInput.Move 0, 0, ScaleWidth
    Height = txtInput.Height
End Sub

' Return the control's font (delegated to txtInput).
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = txtInput.Font
End Property

' Set the control's font (delegated to txtInput).
Public Property Set Font(ByVal New_Font As Font)
    Set txtInput.Font = New_Font
    PropertyChanged "Font"
End Property

' Return the control's minimum allowed value.
Public Property Get MinValue() As Integer
    MinValue = m_MinValue
End Property

' Set the control's minimum allowed value.
Public Property Let MinValue(ByVal New_MinValue As Integer)
    m_MinValue = New_MinValue
    PropertyChanged "MinValue"
End Property

' Return the control's maximum allowed value.
Public Property Get MaxValue() As Integer
    MaxValue = m_MaxValue
End Property
' Set the control's maximum allowed value.
Public Property Let MaxValue(ByVal New_MaxValue As Integer)
    m_MaxValue = New_MaxValue
    PropertyChanged "MaxValue"
End Property

' Return the value indicating whether input is
' allowed (delegated to txtInput).
Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
    Locked = txtInput.Locked
End Property

' Set the value indicating whether input is
' allowed (delegated to txtInput).
Public Property Let Locked(ByVal New_Locked As Boolean)
    txtInput.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

' Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_MinValue = m_def_MinValue
    m_MaxValue = m_def_MaxValue
End Sub

' Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set txtInput.Font = PropBag.ReadProperty("Font", Ambient.Font)
    txtInput.Locked = PropBag.ReadProperty("Locked", False)
    m_MinValue = PropBag.ReadProperty("MinValue", m_def_MinValue)
    m_MaxValue = PropBag.ReadProperty("MaxValue", m_def_MaxValue)
    txtInput.Text = PropBag.ReadProperty("Text", "")
End Sub

' Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Font", txtInput.Font, Ambient.Font)
    Call PropBag.WriteProperty("Locked", txtInput.Locked, False)
    Call PropBag.WriteProperty("MinValue", m_MinValue, m_def_MinValue)
    Call PropBag.WriteProperty("MaxValue", m_MaxValue, m_def_MaxValue)
    Call PropBag.WriteProperty("Text", txtInput.Text, "")
End Sub
' Raise the delegated Change event.
Private Sub txtInput_Change()
    RaiseEvent Change
End Sub
' Return the field's text (delegated to txtInput).
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
    Text = txtInput.Text
End Property

' Set the field's text (delegated to txtInput).
Public Property Let Text(ByVal New_Text As String)
Dim new_value As Integer

    ' See if the text is blank.
    If Len(New_Text) > 0 Then
        ' The text is not blank.
        ' See if it is an integer.
        On Error Resume Next
        new_value = CInt(New_Text)
        If Err.Number > 0 Then
            ' This is not an integer.
            Err.Raise intfield_InvalidInteger, _
                "IntField.Text", _
                "Value " & Format$(New_Text) & _
                " is not a valid integer."
        End If

        ' See if the value is in range.
        If (new_value < m_MinValue) Or _
           (new_value > m_MaxValue) _
        Then
            ' The value is out of bounds.
            Err.Raise intfield_ValueOutOfRange, _
                "IntField.Text", _
                "Value " & Format$(New_Text) & _
                " is not between " & _
                Format$(m_MinValue) & " and " & _
                Format$(m_MaxValue) & "."
        End If
    End If

    ' Save the new value.
    txtInput.Text() = New_Text
    PropertyChanged "Text"
End Property
